import { TestBed } from '@angular/core/testing';

import { ActivitiesService } from './activities.service';
import {LocalizationPipe} from './localize';
import {of} from 'rxjs';
import {DataCardService} from '../api/data-card.service';
import {CarePlanService} from '../api/care-plan.service';

describe('ActivitiesService', () => {
  let service: ActivitiesService;

  let dataCardServiceStub: DataCardService;
  let carePlanServiceStub: CarePlanService;

  beforeEach(async () => {
    dataCardServiceStub = {
      activeDataCard$: of({
        CareLevel: '4',
        gestationAge: '22+1 uger',
        term: '05-11-2020',
        multiple: 'Ja',
        Parity: '0',
        conditions: 'Diabetes +',
        translationAssistance: 'Ja',
        smokingStatus: 'Ja'
      }),
    } as any;

    carePlanServiceStub = {
      carePlan$: of({activities: []})
    } as any;

    await TestBed.configureTestingModule({
      declarations: [LocalizationPipe],
      providers: [
        {provide: DataCardService, useValue: dataCardServiceStub},
        {provide: CarePlanService, useValue: carePlanServiceStub},
      ]
    })
      .compileComponents();
  });
  beforeEach(() => {
    TestBed.configureTestingModule({});
    service = TestBed.inject(ActivitiesService);
  });

  it('should be created', () => {
    expect(service).toBeTruthy();
  });
});
