import {Component, forwardRef} from '@angular/core';
import {CreateRegularObservationsRequest} from '@nspop/gm-web-facade-api';
import {ControlContainer, ControlValueAccessor, NG_VALUE_ACCESSOR, NgForm} from '@angular/forms';
import deepEqual from 'deep-equal';

export const APP_EDIT_REGULAR_OBSERVATION_CONTROL_VALUE_ACCESSOR: any = {
  provide: NG_VALUE_ACCESSOR,
  useExisting: forwardRef(() => EditRegularComponent),
  multi: true
};

@Component({
  selector: 'app-edit-regular',
  templateUrl: './edit-regular.component.html',
  styleUrls: ['./edit-regular.component.scss'],
  viewProviders: [ { provide: ControlContainer, useExisting: NgForm } ],
  providers: [APP_EDIT_REGULAR_OBSERVATION_CONTROL_VALUE_ACCESSOR],

})
export class EditRegularComponent implements ControlValueAccessor {
  private observationData: CreateRegularObservationsRequest|undefined;
  private dirtyAble = false;

  public onChangeCallback: (newValue: CreateRegularObservationsRequest|undefined) => any = () => {};
  private onTouchedCallback: () => any = () => {};

  constructor() { }

  get value(): CreateRegularObservationsRequest|undefined {
    return this.observationData;
  }

  set value(value: CreateRegularObservationsRequest|undefined) {
    if (!deepEqual(value, this.observationData)) {
      this.observationData = value;
      if (this.dirtyAble) {
        this.onChangeCallback(value);
      }
      if (!this.dirtyAble && this.observationData) { // We don't want to mark the field as dirty while data gets initialized
        this.dirtyAble = true;
      }
    }
  }

  registerOnChange(fn: any): void {
    this.onChangeCallback = fn;
  }

  registerOnTouched(fn: any): void {
    this.onTouchedCallback = fn;
  }

  writeValue(newValue: CreateRegularObservationsRequest): void {
    this.value = newValue;
  }
}
